/****************************************************************************/
/* LEERS19     (c) Microbotica, S.L. Enero 1998.                            */
/****************************************************************************/
/*                                                                          */
/* Ejemplo de utilizacion de la libreria S19.C.                             */
/*                                                                          */
/*   Este programa lee un archivo en formato .S19 y devuelve el numero de   */
/* bytes que ocupa el codigo, el numero de registros del tipo 1 y la direc- */
/* cion de comienzo del codigo/datos.                                       */
/*                                                                          */
/*--------------------------------------------------------------------------*/
/* web: www.microbotica.es                                                  */
/* mail: info@microbotica.es                                                */
/****************************************************************************/

#include <stdio.h>

#include "s19.h"

int main(void)
{
  S19 mi_s19;               /* Fichero S19        */
  char cad[80];             /* Nombre del fichero */
  char *caderror;           /* Cadena de error    */
  unsigned int dir;         /* Direccion comienzo */
  int ov;


  /* ------------------------------- */
  /* ---- ABRIR EL FICHERO S19 ----- */
  /* --------------------------------*/
  printf ("\nNombre fichero: ");
  scanf("%s",cad);
  if (abrir_s19(cad,&mi_s19,1)==0) {   /* Si se ha producido un error */
    caderror=(char *)geterrors19();    /* Leer la cadena de error     */
    printf ("Error: %s\n",caderror);   /* Imprimir mensaje de error   */
    return 0;
  }
  printf ("\n");

  /* -------------------------------------------- */
  /* ---- MOSTRAR LA INFORMACION DEL FICHERO ---- */
  /* -------------------------------------------- */
  printf ("Numero de registros  : %u\n",getnregs19(mi_s19));
  printf ("Tamano en Bytes      : %u\n",getnbytes19(mi_s19));

  leerdir_s19(mi_s19,1,&dir);   /* Leer direccion del primer registro */
  printf ("Direccion de comienzo: %X\n",dir);

  printf ("Situacion programa   : ");

  switch(situacion_progs19(mi_s19,&ov)) {
    case 1 : printf ("RAM INTERNA");
             if (ov) printf (" (Desbordamiento)");
             break;
    case 2 : printf ("EEPROM INTERNA");
             if (ov) printf ("(Desbordamiento)");
             break;
    case 3 : printf ("RAM EXTERNA");
             break;
  }

  printf ("\n\n");

  /* ------------------------------- */
  /* ---- CERRAR EL FICHERO S19 ---- */
  /* ------------------------------- */
  cerrar_s19(mi_s19);
  return 0;
}
